// This file creates variables
#include "main_functions.h"
#include "location.h"
#include "ICD.h"
#include "stochastic.h"
#include <fstream>
#include <iostream>
#include <vector>
#include <math.h>
#include <time.h>



/////////////////////////////////////////////////////////////////////////////////////
//Function: Creates an arc quality for the roads;
int ArcQuality()
{
	int aa = 0;
	aa = rand()%3 +1;
	return aa;
}


/////////////////////////////////////////////////////////////////////////////////////
//Function: Creates actual demand based on assumed demand
double CreateActualDemand(double demand)
{
	double change, dem;
	
	change = (rand()%31)*demand/100;

	int up_or_down;
	up_or_down = (rand() % 4);
	
	if (up_or_down > 0 )
	{
		dem = demand + change;
	}
	else
	{
		dem = demand - change;
	}

	if ( dem < 0 )
	{	dem = 0;}

	return 
		dem;
}



/////////////////////////////////////////////////////////////////////////////////////
//Function: Creates actual vehicle number in each LDC based on the assumed number
int CreateActualVehicles(int vehicles)
{
	int change, veh;
	
	change = (rand()%101)*vehicles/100;
	
	int up_or_down;
	up_or_down = (rand() % 2);
	
	if (up_or_down == 1)
	{
		veh = vehicles + change;
	}
	else 
		veh = vehicles - change;
		
	if ( veh < 0 )
	{veh = 0;}
		
	return veh;
}





//////////////////////////////////////////////////////////////////////////////////
//FUNCTION Making random numbers in the map/
int RandomCoord()
{
	int a = rand();
	a = a % 1301;
	return a;
}





////////////////////////////////////////////////////////////////////////////////////
//CREATE random coordinate x when quadrant is already decided
int ArcCapacity()
{
	int a = rand();
	a = a % 3 +1;
	return a;
}



////////////////////////////////////////////////////////////////////////////////////
//CREATE random coordinate x when quadrant is already decided
int RandomForKvadrantX(int a)
{
	if ( a == 1 || a == 4)
	{
		return rand()%649 + 650;
	}
	else 
	{
		return rand()%651;
	}
}



////////////////////////////////////////////////////////////////////////////////////
//CREATE random coordinate y when quadrant is already decided
int RandomForKvadrantY(int a)
{
	if ( a == 1 || a == 2)
	{
		return rand()% 649 +650;
	}
	else
	{
		return rand()%651;
	}

}



////////////////////////////////////////////////////////////////////////////////////
//CREATE EARTHQUAKE FUNCTION //////////////////////////////////////////////////////
void CreateEarthquake(Location &earthquake)
{
	earthquake.SetCoordinates(RandomCoord(), RandomCoord());
}





/////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////FUNCTION: creating a stochastic instance ////////////////////////////////////////
void CreateStochastic(Stochastic &instance)
{
	
////Setting B
	cout << "\nNumber of commodity types            :\t";
	int noc;
	cin >> noc;
	instance.SetNumberOfCommodities(noc);

////Setting K
	cout << "\nNumber of utility intervals are sat to:\t4" << endl;
	instance.SetNumberOfUtilityIntervals(4);

////Setting N
	cout << "\nNumber of ICDs are sat to            :\t4\n";
	int icd = 4;
	instance.SetNumberOfICDs(icd);

	cout << "\nNumber of LDCs                       :\t";
	int nol;
	cin >> nol;
	instance.SetNumberOfLDCs(nol);
	
	cout << "\nNumber of PODs                       :\t";
	int nop;
	cin >> nop;
	instance.SetNumberOfPODs(nop);

	instance.SetNumberOfNodes();

////Setting V
	cout << "\nNumber of vehicle types              :\t";
	int nov; 
	cin >> nov;
	instance.SetNumberOfVehicles(nov);

////Setting Budget
	cout << "\nTotal budget                         :\t";
	int b;
	cin >> b;
	instance.SetBudget(b);

////Setting Budget
	cout << "\nBudget penalty                       :\t";
	cin >> instance.budget_penalty;

////Setting max convoy time
	cout << "\nMaximal convoy time                  :\t";
	int ti;
	cin >> ti;
	instance.SetConvoyTime(ti);

////Setting Vehicle capacity in ICD
	cout << "\nVehicle capacity for the one vehicle type in the ICDs:\t";
	int vc;
	cin >> vc;
	instance.SetVehicleCapacityICD(vc);
	cout << endl;

////Setting the commodity sizes
	int com;
	instance.commodity_size.reserve(100);
	for (int i = 0; i <instance.GetNumberOfCommodities() ;i++)
	{
		cout << "Commodity size for commodity " << i+1 << "       :\t";
		cin >> com;
		instance.SetCommoditySize(com);	
	}
	cout << endl;
////Setting the commodity costs
	int costing;
	for (int i = 0; i <instance.GetNumberOfCommodities() ;i++)
	{	
		cout << "Commodity cost for commodity " << i+1 << "       :\t";
		cin >> costing;
		instance.SetCommodityCost(costing);
	}
	cout << endl;

///Setting Vehicle Capacity of those traveling between LDCs/PODs
	
	cout << endl << "The vehicle capacity range: [0, 1000]" << endl; 
	for (int i = 0; i < instance.GetNumberOfVehicles(); i++)
	{	
		int veh;
		cout << "Vehicle capacity for vehicle " << i+1 << "       : \t";
		cin >> veh;
		instance.SetVehicleCapacity(veh);
	}
	cout << endl;

///Setting Vehicle size of those traveling between LDCs/PODs

	for (int i = 0 ; i < instance.GetNumberOfVehicles() ; i++)
	{
		if ( instance.vehicle_capacity[i] <= 250 )
		{
			instance.SetVehicleSize(250);
		}
		else if ( instance.vehicle_capacity[i] > 250 && instance.vehicle_capacity[i] <= 500)
		{
			instance.SetVehicleSize(500);
		}
		else if ( instance.vehicle_capacity[i] > 500 && instance.vehicle_capacity[i] <= 750)
		{
			instance.SetVehicleSize(750);
		}
		else
			instance.SetVehicleSize(1000);

	}
//// Setting the number of possibilities in each scenario tree node
	instance.SetNumberOfStages();
	cout << "\n How many possibilities are there in stage 2? " ;
	double poss2 = 3;
	//cin >> poss2;
	instance.SetNumberOfPoss2(poss2);
	cout << "\n How many possibilities are there in stage 3? " ;
	double poss3 = 3;
	//cin >> poss3;
	instance.SetNumberOfPoss3(poss3);
	instance.SetNumberOfScenarioTreeNodes();

	instance.number_of_LDCs_PODs = instance.GetNumberOfPODs() + instance.GetNumberOfLDCs();
	instance.duplicated_LDCs = instance.GetNumberOfLDCs()+ instance.GetNumberOfLDCs();
	instance.duplicated_PODs = instance.GetNumberOfPODs() + instance.GetNumberOfPODs();
	instance.duplicated_LDCS_PODs = instance.number_of_LDCs_PODs + instance.number_of_LDCs_PODs;

} // end of function CreateStochastic()




///////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////CREATE ICDs FUNCTION ////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////
void CreateStochICDs(ICD &icds, int nummer, Stochastic set)
{
	int sw;
	switch(nummer)
	{
		case 1:
			{
				icds.SetCoordinates(0, 0);
				cout << "The number of vehicles in each ICD?:\t";
				cout << "Number of vehicles in ICD 1 South West?:\t";
				cin >> sw;
				icds.SetNumberOfVehicles(sw);

				break;
			}
		case 2:
			{
				icds.SetCoordinates(0, 1300);
				cout << "Number of vehicles in ICD 2 North West?:\t";
				cin >> sw;
				icds.SetNumberOfVehicles(sw);

				break;
			}
		case 3:
			{
				icds.SetCoordinates(1300,0);
				cout << "Number of vehicles in ICD 3 South East?:\t"; 
				cin >> sw;
				icds.SetNumberOfVehicles(sw);
	
				break;
			}
		case 4:
			{
				icds.SetCoordinates(1300, 1300);
				cout << "Number of vehicles in ICD 4 South West?:\t";
				cin >> sw;
				icds.SetNumberOfVehicles(sw);
		
				break;
			}
	}
		
		
	int supp;	
	for (int i = 0; i < set.GetNumberOfCommodities(); i++)
	{
			cout << "Supply in ICD " << nummer << " for commodity " << i+1 << " is: ";
			cin >> supp;
			icds.SetSupply(supp);
	}
	cout << endl;
					
}



///////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////CREATE LDCs FUNCTION //////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////
void CreateStochLDCs(LDC &ldc, Location earth, Stochastic stocset, int nr)
{
	cout << "For LDC " << nr << ", what is the                     : \n";
	

	cout << "LDC capacity                               : ";
	int cape;
	cin >> cape;
	ldc.SetLdcCapacity(cape);
	
	cout << "Opening cost                               : ";
	int cost;
	cin >> cost;
	ldc.SetOpeningCost(cost);


	
		//Creates an empty vector of i x k size
			for (int i = 0 ; i < stocset.GetNumberOfVehicles() ; i++)
			{
				vector<int>row6;
				for (int k = 0 ; k < stocset.GetNumberOfScenarioTreeNodes() ; k++)
				{
					row6.push_back(0) ;
				}
				ldc.vehicles_stages.push_back(row6);
			}
			
	int nu;
	for (int i = 0; i < stocset.GetNumberOfVehicles(); i++)
	{
		cout << "The assumed number of vehicle type " << i+1 << ", available is : ";
		cin >> nu;
		ldc.SetNumberOfVehicles(nu);
		ldc.vehicles_stages[i][0] = nu;
	}	
			int sub3, sub2;
			sub2 = stocset.GetNumberOfPossibilitiesIn2();
			sub3 = stocset.GetNumberOfPossibilitiesIn3();
			for (int  i = 0 ; i < stocset.GetNumberOfVehicles(); i++)
			{
				for (int j = 0 ; j < stocset.GetNumberOfPossibilitiesIn2() ; j++)
				{
					ldc.vehicles_stages[i][j+1] = CreateActualVehicles(ldc.vehicles_stages[i][0]);
					
					for (int k = 0 ; k < stocset.GetNumberOfPossibilitiesIn3() ; k++)
					{
						ldc.vehicles_stages[i][1+sub2 +k +j* sub3] = ldc.vehicles_stages[i][j+1];
					}
				}
			}	

	cout << endl << endl; 
	int a = earth.GetKvadrant();
	ldc.SetCoordinates(RandomForKvadrantX(a), RandomForKvadrantY(a));
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////CREATE Arcs FUNCTION //////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////
void CreateStochArcs(Stochastic instance, std::map<int, ICD>icd, std::map<int, LDC>ldc, std::vector<PODD>pod, Location earthquake, Arcs &arcs)
{
	double distance_x , distance_y;
	int distance, aa, bb, cc, dd;
	aa = 0;
	bb = 0;
	cc = 0;
	dd = 0;

// CREATING THE ALLOWED ARCS LDC
	
	vector<vector<int> >dist;
	dist.resize(instance.duplicated_LDCS_PODs+instance.GetNumberOfLDCs());
	for ( int i = 0 ; i < instance.duplicated_LDCS_PODs + instance.GetNumberOfLDCs(); i++)
	{
		dist[i].assign(instance.duplicated_LDCS_PODs+instance.GetNumberOfLDCs(),0);
	}
	


	for ( int i = 0 ; i < instance.number_of_LDCs_PODs; i++) // PODs and LDCs + Dummy pods
	{
		for (int j = 0 ; j < instance.number_of_LDCs_PODs; j++)
		{
			if ( i == j )
			{
				dist[i][j] = 0;
				
			}
			
			else if ( i < instance.GetNumberOfLDCs() && j < instance.GetNumberOfLDCs())
			{
				distance_x = ldc[i+1+instance.GetNumberOfICDs()].GetCoordinateX()- ldc[j+1+instance.GetNumberOfICDs()].GetCoordinateX();
				distance_y = ldc[i+1+instance.GetNumberOfICDs()].GetCoordinateY()- ldc[j+1+instance.GetNumberOfICDs()].GetCoordinateY();
				distance = int(ceil(sqrt((distance_x*distance_x) + (distance_y*distance_y))));
				dist[i][j] = distance;
			}
			
			else if ( i < instance.GetNumberOfLDCs() && j >= instance.GetNumberOfLDCs())
			{
				distance_x = ldc[i+1+instance.GetNumberOfICDs()].GetCoordinateX()- pod[j-instance.GetNumberOfLDCs()].GetCoordinateX();
				distance_y = ldc[i+1+instance.GetNumberOfICDs()].GetCoordinateY()- pod[j-instance.GetNumberOfLDCs()].GetCoordinateY();
				distance = int(ceil(sqrt((distance_x*distance_x) + (distance_y*distance_y))));
				dist[i][j] = distance;
			}
			
			else if ( i >= instance.GetNumberOfLDCs() && j < instance.GetNumberOfLDCs())
			{
				distance_x = pod[i-instance.GetNumberOfLDCs()].GetCoordinateX()- ldc[j+1+instance.GetNumberOfICDs()].GetCoordinateX();
				distance_y = pod[i-instance.GetNumberOfLDCs()].GetCoordinateY()- ldc[j+1+instance.GetNumberOfICDs()].GetCoordinateY();
				distance = int(ceil(sqrt((distance_x*distance_x) + (distance_y*distance_y))));
				dist[i][j] = distance;
				dist[i+instance.number_of_LDCs_PODs][j+instance.number_of_LDCs_PODs] = distance;
			}
			
			else if ( i >= instance.GetNumberOfLDCs() && j >= instance.GetNumberOfLDCs() )
			{
				distance_x = pod[i-instance.GetNumberOfLDCs()].GetCoordinateX()- pod[j-instance.GetNumberOfLDCs()].GetCoordinateX();
				distance_y = pod[i-instance.GetNumberOfLDCs()].GetCoordinateY()- pod[j-instance.GetNumberOfLDCs()].GetCoordinateY();
				distance = int(ceil(sqrt((distance_x*distance_x) + (distance_y*distance_y))));
				dist[i][j] = distance;
				dist[i+instance.number_of_LDCs_PODs][j+instance.number_of_LDCs_PODs] = distance;
			}
		}
	}
	

vector<int>row1;
	for (int i = 0 ; i < instance.duplicated_LDCS_PODs ; i++)
	{
		for (int j = 0 ; j < instance.duplicated_LDCS_PODs ;j++)
		{
			row1.push_back(0);
		}
		arcs.possible_arcs_ldc_pod1.push_back(row1);
		row1.clear();
		////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	}
	
	

				
	 
	int smallest1, smallest2;
	for (int i = 0 ; i < instance.number_of_LDCs_PODs ; i++)   
	{
		smallest1 = 10000, smallest2 = 10000;
		
		for (int j = 0 ; j < instance.number_of_LDCs_PODs ; j++)
		{

			if (i != j && dist[i][j] < smallest1 )
			{ 
				aa = i;
				bb = j;
				smallest1 = dist[i][j];
			}
		} 
		//Sets the smallest distances to 1 for both normal and
		//duplicated network
		arcs.possible_arcs_ldc_pod1[aa][bb] = 1;
		arcs.possible_arcs_ldc_pod1[bb][aa] = 1;
		arcs.possible_arcs_ldc_pod1[aa+instance.number_of_LDCs_PODs][bb+instance.number_of_LDCs_PODs] = 1;
		arcs.possible_arcs_ldc_pod1[bb+instance.number_of_LDCs_PODs][aa+instance.number_of_LDCs_PODs] = 1;

		//Sets allowed arcs according to possible arcs
		for (int k = 0 ; k < instance.GetNumberOfVehicles() ; k++)
		{
			// When aa and bb < numberOfLDCs --> dummy pod to dummy pod exist
			if ( aa < instance.GetNumberOfLDCs() && bb < instance.GetNumberOfLDCs())
			{
				arcs.allowed_arcs_ldc[aa+instance.GetNumberOfLDCs()][bb+instance.GetNumberOfLDCs()][k][0] = 1;
				arcs.allowed_arcs_ldc[bb+instance.GetNumberOfLDCs()][aa+instance.GetNumberOfLDCs()][k][0] = 1;
				arcs.allowed_arcs_ldc[bb+instance.GetNumberOfLDCs()+instance.number_of_LDCs_PODs][aa+instance.GetNumberOfLDCs()+instance.number_of_LDCs_PODs][k][0] = 1;
				arcs.allowed_arcs_ldc[aa+instance.GetNumberOfLDCs()+instance.number_of_LDCs_PODs][bb+instance.GetNumberOfLDCs()+instance.number_of_LDCs_PODs][k][0] = 1;
				arcs.allowed_arcs_ldc[aa][bb+ instance.GetNumberOfLDCs()][k][0] = 1;
				arcs.allowed_arcs_ldc[bb+ instance.GetNumberOfLDCs()][aa][k][0] = 0;
				arcs.allowed_arcs_ldc[bb][aa+ instance.GetNumberOfLDCs()][k][0] = 1;
				arcs.allowed_arcs_ldc[aa+ instance.GetNumberOfLDCs()][bb][k][0] = 0;
			}
			// When from LDC to POD
			else if ( aa < instance.GetNumberOfLDCs() && bb >=  instance.GetNumberOfLDCs()) 
			{
				arcs.allowed_arcs_ldc[aa][bb+instance.GetNumberOfLDCs()][k][0] = 1;
				arcs.allowed_arcs_ldc[aa+instance.GetNumberOfLDCs()][bb+instance.GetNumberOfLDCs()][k][0] = 1;
				arcs.allowed_arcs_ldc[bb+instance.GetNumberOfLDCs()][aa+instance.GetNumberOfLDCs()][k][0] = 1;
				arcs.allowed_arcs_ldc[bb+instance.GetNumberOfLDCs()][aa][k][0] = 0; // because of only one way
				arcs.allowed_arcs_ldc[bb+instance.number_of_LDCs_PODs+ instance.GetNumberOfLDCs()][aa+instance.number_of_LDCs_PODs+instance.GetNumberOfLDCs()][k][0] = 1;
				arcs.allowed_arcs_ldc[aa+instance.number_of_LDCs_PODs+instance.GetNumberOfLDCs()][bb+instance.GetNumberOfLDCs()+instance.number_of_LDCs_PODs][k][0] = 1;
			} 
			//When from LDC to POD
			else if ( bb < instance.GetNumberOfLDCs() && aa >= instance.GetNumberOfLDCs())
			{
				arcs.allowed_arcs_ldc[aa+instance.GetNumberOfLDCs()][bb][k][0] = 0; // because of only one way
				arcs.allowed_arcs_ldc[aa+instance.GetNumberOfLDCs()][bb+instance.GetNumberOfLDCs()][k][0] = 1;
				arcs.allowed_arcs_ldc[bb+instance.GetNumberOfLDCs()][aa+instance.GetNumberOfLDCs()][k][0] = 1;
				arcs.allowed_arcs_ldc[bb][aa+instance.GetNumberOfLDCs()][k][0] = 1; 
				arcs.allowed_arcs_ldc[bb+instance.number_of_LDCs_PODs+instance.GetNumberOfLDCs()][aa+instance.number_of_LDCs_PODs+ instance.GetNumberOfLDCs()][k][0] = 1;
				arcs.allowed_arcs_ldc[aa+instance.number_of_LDCs_PODs+ instance.GetNumberOfLDCs()][bb+instance.GetNumberOfLDCs()+instance.number_of_LDCs_PODs][k][0] = 1;
			}
			//When from POD to POD
			else
			{
				arcs.allowed_arcs_ldc[aa+instance.GetNumberOfLDCs()][bb+instance.GetNumberOfLDCs()][k][0] = 1;
				arcs.allowed_arcs_ldc[bb+instance.GetNumberOfLDCs()][aa+instance.GetNumberOfLDCs()][k][0] = 1; 
				arcs.allowed_arcs_ldc[bb+instance.number_of_LDCs_PODs+instance.GetNumberOfLDCs()][aa+instance.number_of_LDCs_PODs+ instance.GetNumberOfLDCs()][k][0] = 1;
				arcs.allowed_arcs_ldc[aa+instance.number_of_LDCs_PODs+instance.GetNumberOfLDCs()][bb+instance.GetNumberOfLDCs()+instance.number_of_LDCs_PODs][k][0] = 1;
			}
			//Allways a link between LDC1 and dummy POD1
			if ( i < instance.GetNumberOfLDCs())
			{
				arcs.allowed_arcs_ldc[i][i+instance.GetNumberOfLDCs()][k][0] = 1;
			}

// Here we make the links for all other scenario tree nodes:				
			for (int mm = 0 ; mm < instance.GetNumberOfPossibilitiesIn3() + instance.GetNumberOfPossibilitiesIn2() ; mm++)
			{
				// When aa and bb < numberOfLDCs --> dummy pod to dummy pod exist
				if ( aa < instance.GetNumberOfLDCs() && bb < instance.GetNumberOfLDCs())
				{
					arcs.allowed_arcs_ldc[aa+instance.GetNumberOfLDCs()][bb+instance.GetNumberOfLDCs()][k][mm+1] = 1;
					arcs.allowed_arcs_ldc[bb+instance.GetNumberOfLDCs()][aa+instance.GetNumberOfLDCs()][k][mm+1] = 1;
					arcs.allowed_arcs_ldc[bb+instance.GetNumberOfLDCs()+instance.number_of_LDCs_PODs][aa+instance.GetNumberOfLDCs()+instance.number_of_LDCs_PODs][k][mm+1] = 1;
					arcs.allowed_arcs_ldc[aa+instance.GetNumberOfLDCs()+instance.number_of_LDCs_PODs][bb+instance.GetNumberOfLDCs()+instance.number_of_LDCs_PODs][k][mm+1] = 1;
					arcs.allowed_arcs_ldc[aa][bb+ instance.GetNumberOfLDCs()][k][mm+1] = 1;
					arcs.allowed_arcs_ldc[bb+ instance.GetNumberOfLDCs()][aa][k][mm+1] = 0;
					arcs.allowed_arcs_ldc[bb][aa+ instance.GetNumberOfLDCs()][k][mm+1] = 1;
					arcs.allowed_arcs_ldc[aa+ instance.GetNumberOfLDCs()][bb][k][mm+1] = 0;
				}
				// When from LDC to POD
				else if ( aa < instance.GetNumberOfLDCs() && bb >=  instance.GetNumberOfLDCs()) 
				{
					arcs.allowed_arcs_ldc[aa][bb+instance.GetNumberOfLDCs()][k][mm+1] = 1;
					arcs.allowed_arcs_ldc[aa+instance.GetNumberOfLDCs()][bb+instance.GetNumberOfLDCs()][k][mm+1] = 1;
					arcs.allowed_arcs_ldc[bb+instance.GetNumberOfLDCs()][aa+instance.GetNumberOfLDCs()][k][mm+1] = 1;
					arcs.allowed_arcs_ldc[bb+instance.GetNumberOfLDCs()][aa][k][mm+1] = 0; // because of only one way
					arcs.allowed_arcs_ldc[bb+instance.number_of_LDCs_PODs+ instance.GetNumberOfLDCs()][aa+instance.number_of_LDCs_PODs+instance.GetNumberOfLDCs()][k][mm+1] = 1;
					arcs.allowed_arcs_ldc[aa+instance.number_of_LDCs_PODs+instance.GetNumberOfLDCs()][bb+instance.GetNumberOfLDCs()+instance.number_of_LDCs_PODs][k][mm+1] = 1;
				} 
				//When from LDC to POD
				else if ( bb < instance.GetNumberOfLDCs() && aa >= instance.GetNumberOfLDCs())
				{
					arcs.allowed_arcs_ldc[aa+instance.GetNumberOfLDCs()][bb][k][mm+1] = 0; // because of only one way
					arcs.allowed_arcs_ldc[aa+instance.GetNumberOfLDCs()][bb+instance.GetNumberOfLDCs()][k][mm+1] = 1;
					arcs.allowed_arcs_ldc[bb+instance.GetNumberOfLDCs()][aa+instance.GetNumberOfLDCs()][k][mm+1] = 1;
					arcs.allowed_arcs_ldc[bb][aa+instance.GetNumberOfLDCs()][k][mm+1] = 1; 
					arcs.allowed_arcs_ldc[bb+instance.number_of_LDCs_PODs+instance.GetNumberOfLDCs()][aa+instance.number_of_LDCs_PODs+ instance.GetNumberOfLDCs()][k][mm+1] = 1;
					arcs.allowed_arcs_ldc[aa+instance.number_of_LDCs_PODs+ instance.GetNumberOfLDCs()][bb+instance.GetNumberOfLDCs()+instance.number_of_LDCs_PODs][k][mm+1] = 1;
				}
				//When from POD to POD
				else
				{
					arcs.allowed_arcs_ldc[aa+instance.GetNumberOfLDCs()][bb+instance.GetNumberOfLDCs()][k][mm+1] = 1;
					arcs.allowed_arcs_ldc[bb+instance.GetNumberOfLDCs()][aa+instance.GetNumberOfLDCs()][k][mm+1] = 1; 
					arcs.allowed_arcs_ldc[bb+instance.number_of_LDCs_PODs+instance.GetNumberOfLDCs()][aa+instance.number_of_LDCs_PODs+ instance.GetNumberOfLDCs()][k][mm+1] = 1;
					arcs.allowed_arcs_ldc[aa+instance.number_of_LDCs_PODs+instance.GetNumberOfLDCs()][bb+instance.GetNumberOfLDCs()+ instance.number_of_LDCs_PODs][k][mm+1] = 1;
				}
			//Allways a link between LDC1 and dummy POD1
				if ( i < instance.GetNumberOfLDCs())
				{
					arcs.allowed_arcs_ldc[i][i+instance.GetNumberOfLDCs()][k][mm+1]=1;
				}
			
			}	

		}
		
		// Here we start with the next shortest path and repeat the session from above
		for (int j = 0 ; j < instance.number_of_LDCs_PODs ; j++)
		{
			if ( !( i == aa && j == bb ) && i != j && dist[i][j] < smallest2)
			{ 
				cc = i;
				dd = j;
				smallest2 = dist[i][j];
			}
		}
		arcs.possible_arcs_ldc_pod1[cc][dd] = 1;
		arcs.possible_arcs_ldc_pod1[dd][cc] = 1;
		arcs.possible_arcs_ldc_pod1[cc +instance.number_of_LDCs_PODs][dd+instance.number_of_LDCs_PODs] = 1;
		arcs.possible_arcs_ldc_pod1[dd +instance.number_of_LDCs_PODs][cc+instance.number_of_LDCs_PODs] = 1;
		
		for ( int k = 0 ; k < instance.GetNumberOfVehicles() ; k++)
		{
			// When aa and bb < numberOfLDCs --> dummy pod to dummy pod exist
			if ( cc < instance.GetNumberOfLDCs() && dd < instance.GetNumberOfLDCs())
			{
				arcs.allowed_arcs_ldc[cc+instance.GetNumberOfLDCs()][dd+instance.GetNumberOfLDCs()][k][0] = 1;
				arcs.allowed_arcs_ldc[dd+instance.GetNumberOfLDCs()][cc+instance.GetNumberOfLDCs()][k][0] = 1;
				arcs.allowed_arcs_ldc[dd+instance.GetNumberOfLDCs()+instance.number_of_LDCs_PODs][cc+instance.GetNumberOfLDCs()+instance.number_of_LDCs_PODs][k][0] = 1;
				arcs.allowed_arcs_ldc[cc+instance.GetNumberOfLDCs()+instance.number_of_LDCs_PODs][dd+instance.GetNumberOfLDCs()+instance.number_of_LDCs_PODs][k][0] = 1;
				arcs.allowed_arcs_ldc[cc][dd+ instance.GetNumberOfLDCs()][k][0] = 1;
				arcs.allowed_arcs_ldc[dd+ instance.GetNumberOfLDCs()][cc][k][0] = 0;
				arcs.allowed_arcs_ldc[dd][cc+ instance.GetNumberOfLDCs()][k][0] = 1;
				arcs.allowed_arcs_ldc[cc+ instance.GetNumberOfLDCs()][dd][k][0] = 0;
			}
			// When from LDC to POD
			else if ( cc < instance.GetNumberOfLDCs() && dd >=  instance.GetNumberOfLDCs()) 
			{
				arcs.allowed_arcs_ldc[cc][dd+instance.GetNumberOfLDCs()][k][0] = 1;
				arcs.allowed_arcs_ldc[cc+instance.GetNumberOfLDCs()][dd+instance.GetNumberOfLDCs()][k][0] = 1;
				arcs.allowed_arcs_ldc[dd+instance.GetNumberOfLDCs()][cc+instance.GetNumberOfLDCs()][k][0] = 1;
				arcs.allowed_arcs_ldc[dd+instance.GetNumberOfLDCs()][cc][k][0] = 0; // because of only one way
				arcs.allowed_arcs_ldc[dd+instance.number_of_LDCs_PODs+ instance.GetNumberOfLDCs()][cc+instance.number_of_LDCs_PODs+instance.GetNumberOfLDCs()][k][0] = 1;
				arcs.allowed_arcs_ldc[cc+instance.number_of_LDCs_PODs+instance.GetNumberOfLDCs()][dd+instance.GetNumberOfLDCs()+instance.number_of_LDCs_PODs][k][0] = 1;
			} 
			//When from LDC to POD
			else if ( dd < instance.GetNumberOfLDCs() && cc >= instance.GetNumberOfLDCs())
			{
				arcs.allowed_arcs_ldc[cc+instance.GetNumberOfLDCs()][dd][k][0] = 0; // because of only one way
				arcs.allowed_arcs_ldc[cc+instance.GetNumberOfLDCs()][dd+instance.GetNumberOfLDCs()][k][0] = 1;
				arcs.allowed_arcs_ldc[dd+instance.GetNumberOfLDCs()][cc+instance.GetNumberOfLDCs()][k][0] = 1;
				arcs.allowed_arcs_ldc[dd][cc+instance.GetNumberOfLDCs()][k][0] = 1; 
				arcs.allowed_arcs_ldc[dd+instance.number_of_LDCs_PODs+instance.GetNumberOfLDCs()][cc+instance.number_of_LDCs_PODs+ instance.GetNumberOfLDCs()][k][0] = 1;
				arcs.allowed_arcs_ldc[cc+instance.number_of_LDCs_PODs+ instance.GetNumberOfLDCs()][dd+instance.GetNumberOfLDCs()+instance.number_of_LDCs_PODs][k][0] = 1;
			}
			//When from POD to POD
			else
			{
				arcs.allowed_arcs_ldc[cc+instance.GetNumberOfLDCs()][dd+instance.GetNumberOfLDCs()][k][0] = 1;
				arcs.allowed_arcs_ldc[dd+instance.GetNumberOfLDCs()][cc+instance.GetNumberOfLDCs()][k][0] = 1; 
				arcs.allowed_arcs_ldc[dd+instance.number_of_LDCs_PODs+instance.GetNumberOfLDCs()][cc+instance.number_of_LDCs_PODs+ instance.GetNumberOfLDCs()][k][0] = 1;
				arcs.allowed_arcs_ldc[cc+instance.number_of_LDCs_PODs+instance.GetNumberOfLDCs()][dd+instance.GetNumberOfLDCs()+instance.number_of_LDCs_PODs][k][0] = 1;
			}
			//Allways a link between LDC1 and dummy POD1
			if ( i < instance.GetNumberOfLDCs())
			{
				arcs.allowed_arcs_ldc[i][i+instance.GetNumberOfLDCs()][k][0] = 1;
			}

// Here we make the links for all other scenario tree nodes:				
			for (int m = 0 ; m < instance.GetNumberOfPossibilitiesIn3() + instance.GetNumberOfPossibilitiesIn2() ; m++)
			{
				// When aa and bb < numberOfLDCs --> dummy pod to dummy pod exist
				if ( cc < instance.GetNumberOfLDCs() && dd < instance.GetNumberOfLDCs())
				{
					arcs.allowed_arcs_ldc[cc+instance.GetNumberOfLDCs()][dd+instance.GetNumberOfLDCs()][k][m+1] = 1;
					arcs.allowed_arcs_ldc[dd+instance.GetNumberOfLDCs()][cc+instance.GetNumberOfLDCs()][k][m+1] = 1;
					arcs.allowed_arcs_ldc[dd+instance.GetNumberOfLDCs()+instance.number_of_LDCs_PODs][cc+instance.GetNumberOfLDCs()+instance.number_of_LDCs_PODs][k][m+1] = 1;
					arcs.allowed_arcs_ldc[cc+instance.GetNumberOfLDCs()+instance.number_of_LDCs_PODs][dd+instance.GetNumberOfLDCs()+instance.number_of_LDCs_PODs][k][m+1] = 1;
					arcs.allowed_arcs_ldc[cc][dd+ instance.GetNumberOfLDCs()][k][m+1] = 1;
					arcs.allowed_arcs_ldc[dd+ instance.GetNumberOfLDCs()][cc][k][m+1] = 0;
					arcs.allowed_arcs_ldc[dd][cc+ instance.GetNumberOfLDCs()][k][m+1] = 1;
					arcs.allowed_arcs_ldc[cc+ instance.GetNumberOfLDCs()][dd][k][m+1] = 0;
				}
				// When from LDC to POD
				else if ( cc < instance.GetNumberOfLDCs() && dd >=  instance.GetNumberOfLDCs()) 
				{
					arcs.allowed_arcs_ldc[cc][dd+instance.GetNumberOfLDCs()][k][m+1] = 1;
					arcs.allowed_arcs_ldc[cc+instance.GetNumberOfLDCs()][dd+instance.GetNumberOfLDCs()][k][m+1] = 1;
					arcs.allowed_arcs_ldc[dd+instance.GetNumberOfLDCs()][cc+instance.GetNumberOfLDCs()][k][m+1] = 1;
					arcs.allowed_arcs_ldc[dd+instance.GetNumberOfLDCs()][cc][k][m+1] = 0; // because of only one way
					arcs.allowed_arcs_ldc[dd+instance.number_of_LDCs_PODs+ instance.GetNumberOfLDCs()][cc+instance.number_of_LDCs_PODs+instance.GetNumberOfLDCs()][k][m+1] = 1;
					arcs.allowed_arcs_ldc[cc+instance.number_of_LDCs_PODs+instance.GetNumberOfLDCs()][dd+instance.GetNumberOfLDCs()+instance.number_of_LDCs_PODs][k][m+1] = 1;
				} 
				//When from LDC to POD
				else if ( dd < instance.GetNumberOfLDCs() && cc >= instance.GetNumberOfLDCs())
				{
					arcs.allowed_arcs_ldc[cc+instance.GetNumberOfLDCs()][dd][k][m+1] = 0; // because of only one way
					arcs.allowed_arcs_ldc[cc+instance.GetNumberOfLDCs()][dd+instance.GetNumberOfLDCs()][k][m+1] = 1;
					arcs.allowed_arcs_ldc[dd+instance.GetNumberOfLDCs()][cc+instance.GetNumberOfLDCs()][k][m+1] = 1;
					arcs.allowed_arcs_ldc[dd][cc+instance.GetNumberOfLDCs()][k][m+1] = 1; 
					arcs.allowed_arcs_ldc[dd+instance.number_of_LDCs_PODs+instance.GetNumberOfLDCs()][cc+instance.number_of_LDCs_PODs+ instance.GetNumberOfLDCs()][k][m+1] = 1;
					arcs.allowed_arcs_ldc[cc+instance.number_of_LDCs_PODs+ instance.GetNumberOfLDCs()][dd+instance.GetNumberOfLDCs()+instance.number_of_LDCs_PODs][k][m+1] = 1;
				}
				//When from POD to POD
				else
				{
					arcs.allowed_arcs_ldc[cc+instance.GetNumberOfLDCs()][dd+instance.GetNumberOfLDCs()][k][m+1] = 1;
					arcs.allowed_arcs_ldc[dd+instance.GetNumberOfLDCs()][cc+instance.GetNumberOfLDCs()][k][m+1] = 1; 
					arcs.allowed_arcs_ldc[dd+instance.number_of_LDCs_PODs+instance.GetNumberOfLDCs()][cc+instance.number_of_LDCs_PODs+ instance.GetNumberOfLDCs()][k][m+1] = 1;
					arcs.allowed_arcs_ldc[cc+instance.number_of_LDCs_PODs+instance.GetNumberOfLDCs()][dd+instance.GetNumberOfLDCs()+ instance.number_of_LDCs_PODs][k][m+1] = 1;
				}
			}
		}
	}
	
for ( int i = 0 ; i < instance.number_of_LDCs_PODs ; i++)
{
	arcs.possible_arcs_ldc_pod1[i][i+instance.number_of_LDCs_PODs] = 1;
	arcs.possible_arcs_ldc_pod1[i+instance.number_of_LDCs_PODs][i] = 1;
}




for (int i = 0 ; i < instance.duplicated_LDCS_PODs ; i++) 
{ 
	for (int j = 0 ; j < instance.duplicated_LDCS_PODs ; j++) 
	{ 
		// Not allowed to travel inside its own node
		if ( i == j ) 
		{ 
			arcs.possible_arcs_ldc_pod1[i][j] = 0 ; 
			arcs.possible_arcs_ldc_pod1[j][i] = 0 ; 
		} 
	}
}
// Making sure allowed arcs ldc from LDC to POD and travelling in itself...
for (int i = 0 ; i < instance.duplicated_LDCS_PODs + instance.GetNumberOfLDCs() ; i++)
{
	for (int j = 0 ; j < instance.duplicated_LDCS_PODs + instance.GetNumberOfLDCs() ; j++)
	{
		for (int k = 0 ; k < instance.GetNumberOfVehicles() ; k++) 
		{ 
			for (int mm = 0 ; mm < instance.GetNumberOfScenarioTreeNodes() ; mm++) 
			{ 
				// Not allowed to travel within a node
				if ( i == j ) 
				{
					arcs.allowed_arcs_ldc[i][j][k][mm] = 0; 
					arcs.allowed_arcs_ldc[j][i][k][mm] = 0; 
				} 
				// Allways allowed to travel from LDC to its respective dummy POD, but not the opposite way, in ALL scenario tree nodes
				if (i < instance.GetNumberOfLDCs() && j == i + instance.GetNumberOfLDCs() )
				{ 
					arcs.allowed_arcs_ldc[i][j][k][mm] = 0; 
					arcs.allowed_arcs_ldc[j][i][k][mm] = 0; 
				} 
			} 
		} 
	} 
}

for (int i = 0 ; i < instance.number_of_LDCs_PODs + instance.GetNumberOfLDCs() ; i++)
{
	
		for (int k = 0 ; k < instance.GetNumberOfVehicles() ; k++) 
		{ 
			for (int mm = 0 ; mm < instance.GetNumberOfScenarioTreeNodes() ; mm++) 
			{ 
				if ( i < instance.GetNumberOfLDCs())
				{
					arcs.allowed_arcs_ldc[i][i+instance.number_of_LDCs_PODs+instance.GetNumberOfLDCs()][k][mm] = 1;
					arcs.allowed_arcs_ldc[i+instance.number_of_LDCs_PODs+instance.GetNumberOfLDCs()][i][k][mm] = 0;
				}
				else
				{
					arcs.allowed_arcs_ldc[i][i+instance.number_of_LDCs_PODs][k][mm] = 1;
					arcs.allowed_arcs_ldc[i+instance.number_of_LDCs_PODs][i][k][mm] = 1;
				}
			}
		}
	
}
///////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////


// Creating arc_quality[DUP+NLDC][DUP+NLDC] and arc_capacity [DUP+NLDC][DUP+NLDC][Number of scenario tree nodes]
	vector<int>row7;
	vector<vector<int> >row8;
	vector<int>row9;
	for (int i = 0 ; i < instance.duplicated_LDCS_PODs + instance.GetNumberOfLDCs() ; i++)
	{
		for (int j = 0 ; j < instance.duplicated_LDCS_PODs + instance.GetNumberOfLDCs() ; j++)
		{
			row7.push_back(-1);
			for (int k = 0 ; k < instance.GetNumberOfScenarioTreeNodes() ; k++)
			{
				row9.push_back(0);
			}
			row8.push_back(row9);
			row9.clear();
		}
		arcs.arc_quality.push_back(row7);
		arcs.arc_capacity.push_back(row8);
		row7.clear();
		row8.clear();
		
	}
		

	// Setting qualities for every existing arcs.
	for (int i = 0 ; i < instance.duplicated_LDCS_PODs +instance.GetNumberOfLDCs(); i++)
	{
		for (int j = 0 ; j < instance.duplicated_LDCS_PODs + instance.GetNumberOfLDCs(); j++)
		{
			for (int k = 0 ; k < instance.GetNumberOfVehicles() ; k++)
			{
				if (arcs.allowed_arcs_ldc[i][j][k][0] == 1 )
				{
					if (arcs.arc_quality[i][j] == - 1 ) // This arc has not yet recieved a quality
					{
						//From LDC to its dummy POD quality is allways 00 and 0 opposite direction
						if ( i < instance.GetNumberOfLDCs() && j == i + instance.GetNumberOfLDCs())
						{
							arcs.arc_quality[i][j] = 0;
							arcs.arc_quality[j][i] = 0;
						}
						//form LDC to any other node with an existing arc, quality must be equal as from the dummy to the other node
						else if ( i < instance.GetNumberOfLDCs() && j != i + instance.GetNumberOfLDCs() && j < instance.number_of_LDCs_PODs+instance.GetNumberOfLDCs())
						{
							arcs.arc_quality[i][j] =  ArcQuality();
							arcs.arc_quality[i+instance.GetNumberOfLDCs()][j] = arcs.arc_quality[i][j];
							arcs.arc_quality[j][i+instance.GetNumberOfLDCs()] = arcs.arc_quality[i][j];
							arcs.arc_quality[i+instance.GetNumberOfLDCs()+instance.number_of_LDCs_PODs][j+instance.number_of_LDCs_PODs]= arcs.arc_quality[i][j];
							arcs.arc_quality[j+instance.number_of_LDCs_PODs][i+instance.number_of_LDCs_PODs+instance.GetNumberOfLDCs()]= arcs.arc_quality[i][j];
							arcs.arc_quality[j][i] = 0;
							arcs.arc_quality[j-instance.GetNumberOfLDCs()][i+instance.GetNumberOfLDCs()] = arcs.arc_quality[i][j];
  						}
						else if ( i < instance.GetNumberOfLDCs() && j >= instance.number_of_LDCs_PODs + instance.GetNumberOfLDCs() )
						{
							arcs.arc_quality[i][j] = 1000;
							arcs.arc_quality[j][i] = 0;
						}
						else if ( i >= instance.GetNumberOfLDCs() && i < 2*instance.GetNumberOfLDCs() && j >= instance.GetNumberOfLDCs()+instance.number_of_LDCs_PODs)
						{
							arcs.arc_quality[i][j] = 1000;
							arcs.arc_quality[j][i] = 1000;
						}
						else if (i >= instance.GetNumberOfLDCs() && i < (instance.number_of_LDCs_PODs + instance.GetNumberOfLDCs()) && j < (instance.number_of_LDCs_PODs + instance.GetNumberOfLDCs()) && j >= instance.GetNumberOfLDCs())
						{ //i,j > number_of_LDCs  i < number_of_LDCs_PODs+NLDC
							arcs.arc_quality[i][j] = ArcQuality(); // Gives the arcs a certain quality.
							arcs.arc_quality[j][i] = arcs.arc_quality[i][j];
							arcs.arc_quality[i+instance.number_of_LDCs_PODs][j+instance.number_of_LDCs_PODs] = arcs.arc_quality[i][j];
							arcs.arc_quality[j+instance.number_of_LDCs_PODs][i+instance.number_of_LDCs_PODs] = arcs.arc_quality[i][j];
						
							arcs.arc_quality[i][i+instance.number_of_LDCs_PODs]= 1000;
							arcs.arc_quality[j][j+instance.number_of_LDCs_PODs]= 1000;
							arcs.arc_quality[i+instance.number_of_LDCs_PODs][i]= 1000;
							arcs.arc_quality[j+instance.number_of_LDCs_PODs][j]= 1000;
						}
					}
				}
			
				else 
				{
					arcs.arc_quality[i][j] = 0;
				}
			}
		}
	}


for ( int i = 0 ; i < instance.number_of_LDCs_PODs+ instance.GetNumberOfLDCs(); i++)
{
	if ( i < instance.GetNumberOfLDCs())
	{
		arcs.arc_quality[i][i + instance.number_of_LDCs_PODs+instance.GetNumberOfLDCs()]  = 1000;
		arcs.arc_quality[i+instance.GetNumberOfLDCs()+instance.number_of_LDCs_PODs][i] = 0;
	}
	else
	{
		arcs.arc_quality[i][i + instance.number_of_LDCs_PODs] = 1000;
		arcs.arc_quality[i + instance.number_of_LDCs_PODs][i] = 1000;
	}
}
		// For Stage 1-3
	for (int i = 0 ; i < instance.number_of_LDCs_PODs  + instance.GetNumberOfLDCs() ; i++)
	{
		for (int j = 0 ; j < instance.number_of_LDCs_PODs  + instance.GetNumberOfLDCs() ; j++)
		{						
			for (int k = 0 ; k < instance.GetNumberOfVehicles() ; k++)
			{
				for (int mm = 0 ; mm < instance.GetNumberOfScenarioTreeNodes() ; mm++)
				{
	
					//We look at LDC to dummy POD 
					if ( i < instance.GetNumberOfLDCs() && j == i + instance.GetNumberOfLDCs() && j < instance.GetNumberOfLDCs()+instance.number_of_LDCs_PODs)
					{
						arcs.arc_quality[i][j] = 0;
						arcs.allowed_arcs_ldc[i][j][k][mm] = 0;
						arcs.arc_capacity[i][j][mm ] = 0;
						arcs.arc_capacity[j][i][mm ] = 0;
						arcs.arc_quality[j][i] = 0;
						arcs.allowed_arcs_ldc[j][i][k][mm] = 0;
					}
					//we look at LDC to other nodes
					else if ( i < instance.GetNumberOfLDCs() && j != i + instance.GetNumberOfLDCs() && j >= instance.GetNumberOfLDCs())
					{
						arcs.arc_quality[i][j]= arcs.arc_quality[i+instance.GetNumberOfLDCs()][j];
						arcs.arc_quality[j][i+instance.GetNumberOfLDCs()] = arcs.arc_quality[i][j];
						arcs.arc_capacity[i][j][mm] = arcs.arc_capacity[i+instance.GetNumberOfLDCs()][j][0];
						arcs.arc_capacity[j][i][mm] = 0;
						arcs.allowed_arcs_ldc[i][j][k][mm] = arcs.allowed_arcs_ldc[i+instance.GetNumberOfLDCs()][j][k][0];
						arcs.allowed_arcs_ldc[j][i][k][mm] = 0;
					}
				}
			}
		}
	}	

	//Making sure allowed arcs ldc is zero for to duplicated network in stage 1 and 2
	for (int i = 0 ; i < instance.number_of_LDCs_PODs  + instance.GetNumberOfLDCs() ; i++)
	{					
			for (int k = 0 ; k < instance.GetNumberOfVehicles() ; k++)
			{
				for (int mm = 0 ; mm < 1+ instance.GetNumberOfPossibilitiesIn2() ; mm++)
				{
					if ( i < instance.GetNumberOfLDCs() )
					{
						arcs.allowed_arcs_ldc[i][i+2*instance.GetNumberOfLDCs()+instance.GetNumberOfPODs()][k][mm] = 0; 
						arcs.allowed_arcs_ldc[i+2*instance.GetNumberOfLDCs()+instance.GetNumberOfPODs()][i][k][mm] = 0;
					}
					else
					{
						arcs.allowed_arcs_ldc[i][i + instance.GetNumberOfLDCs() + instance.GetNumberOfPODs()][k][mm] = 0 ;
						arcs.allowed_arcs_ldc[i + instance.GetNumberOfLDCs() + instance.GetNumberOfPODs()][i][k][mm] = 0 ;
					}
				}
			}
	}


//Setting the arc capacity
	for (int i = 0 ; i < instance.duplicated_LDCS_PODs + instance.GetNumberOfLDCs() ; i++)
	{
		for (int j = 0 ; j < instance.duplicated_LDCS_PODs + instance.GetNumberOfLDCs() ; j++)
		{
			for (int mm = 0 ; mm <instance.GetNumberOfScenarioTreeNodes() ; mm++)
			{
				arcs.arc_capacity[i][j][mm] = 1000 * arcs.arc_quality[i][j];
				arcs.arc_capacity[j][i][mm] = 1000 * arcs.arc_quality[j][i];
			}
		}
	}
	



	int distance_earth[250];
	double distance_xx, distance_yy;
	int distance2;
	// The distance from each node to the epicenter
	for (int j = 0 ; j < instance.GetNumberOfLDCs() ; j++)
	{
		distance_xx = ldc[j+1+instance.GetNumberOfICDs()].GetCoordinateX()- earthquake.GetCoordinateX();
		distance_yy = ldc[j+1+instance.GetNumberOfICDs()].GetCoordinateY()-  earthquake.GetCoordinateY();
		distance2 = int(ceil(sqrt((distance_xx*distance_xx) + (distance_yy*distance_yy))));
		distance_earth[j] = distance2;
		distance_earth[j+instance.GetNumberOfLDCs()] = distance2;
	}
	
	for (int i = 0 ; i < instance.GetNumberOfPODs() ; i++)
	{
		distance_xx = pod[i].GetCoordinateX()- earthquake.GetCoordinateX();
		distance_yy = pod[i].GetCoordinateY()- earthquake.GetCoordinateY();
		distance2 = int(ceil(sqrt((distance_xx*distance_xx) + (distance_yy*distance_yy))));
		distance_earth[i+instance.GetNumberOfLDCs()+instance.GetNumberOfLDCs()] = distance2;
	}	
	
	vector<vector<int> >arc_quality2;
	vector<int>row111;
	for (int i = 0 ; i < instance.number_of_LDCs_PODs + instance.GetNumberOfLDCs() ; i++)
	{
		for (int j = 0 ; j < instance.number_of_LDCs_PODs + instance.GetNumberOfLDCs() ;j++)
		{
			row111.push_back(0);
		}
		arc_quality2.push_back(row111);
		row111.clear();
	}
	for (int i = 0 ; i < instance.number_of_LDCs_PODs + instance.GetNumberOfLDCs() ; i++)
	{
		for (int j = 0 ; j < instance.number_of_LDCs_PODs + instance.GetNumberOfLDCs() ; j++)
		{	
			arc_quality2[i][j] = arcs.arc_quality[i][j]; //arc_quality2 has information of quality of first and second stage
		}
	}


	int count = 0;
	//For stage 3, create a quality that decides if the arc will still be there
	int teller;
	for (int i = 0 ; i < instance.number_of_LDCs_PODs  + instance.GetNumberOfLDCs() ; i++)
	{
		for (int j = 0 ; j < instance.number_of_LDCs_PODs  + instance.GetNumberOfLDCs() ; j++)
		{						
			for (int k = 0 ; k < instance.GetNumberOfVehicles() ; k++)
			{
					for (int mm = 0 ; mm < instance.GetNumberOfScenarioTreeNodes()-instance.GetNumberOfPossibilitiesIn2() -1 ; mm++)
					{
						//We only look at the dummy nodes and the pods (not LDCs):
						if ( i >= instance.GetNumberOfLDCs() && j >= instance.GetNumberOfLDCs())
						{
							if ( arc_quality2[i][j] != 0 ) // meaning allowed arcs in first stage is > 0
							{
								if ( arc_quality2[i][j]== 1000)
								{
									arcs.arc_capacity[i][j][mm]= 1000;
									arcs.arc_quality[i][j] = 1000;
								}
								else
								{
									teller = CreateRandomQuality(arc_quality2[i][j], distance_earth[i], distance_earth[j]);
									
									if ( arcs.arc_quality[i][j] == -1  || arcs.arc_quality[i][j] == 0) 
									arcs.arc_quality[i][j] = teller;
									arcs.arc_quality[j][i] = teller ;
							
									if (teller != 0)
									{
										arcs.allowed_arcs_ldc[i][j][k][mm+instance.GetNumberOfPossibilitiesIn2()+1] = 1;
										arcs.allowed_arcs_ldc[j][i][k][mm+instance.GetNumberOfPossibilitiesIn2()+1] = 1;
										arcs.allowed_arcs_ldc[i+instance.number_of_LDCs_PODs][j+instance.number_of_LDCs_PODs][k][mm+instance.GetNumberOfPossibilitiesIn2()+1] = 1;
										arcs.allowed_arcs_ldc[j+instance.number_of_LDCs_PODs][i+instance.number_of_LDCs_PODs][k][mm+instance.GetNumberOfPossibilitiesIn2()+1] = 1;
									}
									else if (teller == 0 )
									{
										arcs.allowed_arcs_ldc[i][j][k][mm+instance.GetNumberOfPossibilitiesIn2()+1] = 0;
										arcs.allowed_arcs_ldc[j][i][k][mm+instance.GetNumberOfPossibilitiesIn2()+1] = 0;
										arcs.allowed_arcs_ldc[i+instance.number_of_LDCs_PODs][j+instance.number_of_LDCs_PODs][k][mm+instance.GetNumberOfPossibilitiesIn2()+1] = 0;
										arcs.allowed_arcs_ldc[j+instance.number_of_LDCs_PODs][i+instance.number_of_LDCs_PODs][k][mm+instance.GetNumberOfPossibilitiesIn2()+1] = 0;
									}
									

								}
							}
							else 
							{
								arcs.allowed_arcs_ldc[i][j][k][mm+instance.GetNumberOfPossibilitiesIn2() + 1] = 0;
								arcs.allowed_arcs_ldc[j][i][k][mm+instance.GetNumberOfPossibilitiesIn2() + 1] = 0;
								arcs.arc_capacity[i][j][mm + instance.GetNumberOfPossibilitiesIn2() +1 ] = 0 ;
								arcs.arc_capacity[j][i][mm + instance.GetNumberOfPossibilitiesIn2() +1 ] = 0 ;
							}
						}
				}
			}
		}
	}



	// For Stage 3
	for (int i = 0 ; i < instance.number_of_LDCs_PODs  + instance.GetNumberOfLDCs() ; i++)
	{
		for (int j = 0 ; j < instance.number_of_LDCs_PODs  + instance.GetNumberOfLDCs() ; j++)
		{						
			for (int k = 0 ; k < instance.GetNumberOfVehicles() ; k++)
			{
				for (int mm = 0 ; mm < instance.GetNumberOfScenarioTreeNodes()-1-instance.GetNumberOfPossibilitiesIn2() ; mm++)
				{
	
					//We look at LDC to dummy POD in stage 3
					if ( i < instance.GetNumberOfLDCs() && j == i + instance.GetNumberOfLDCs())
					{
						arcs.arc_quality[i][j] = 0;
						arcs.allowed_arcs_ldc[i][j][k][mm+instance.GetNumberOfPossibilitiesIn2() +1] = 0;
						arcs.arc_capacity[i][j][mm + instance.GetNumberOfPossibilitiesIn2() +1] = 0;
						arcs.arc_capacity[j][i][mm + instance.GetNumberOfPossibilitiesIn2() +1] = 0;
						arcs.arc_quality[j][i] = 0;
						arcs.allowed_arcs_ldc[j][i][k][mm+instance.GetNumberOfPossibilitiesIn2() +1] = 0;
					}
					//we look at LDC to other nodes
					else if ( i < instance.GetNumberOfLDCs() && j != i + instance.GetNumberOfLDCs() && j >= instance.GetNumberOfLDCs())
					{
						arcs.arc_capacity[i][j][mm+instance.GetNumberOfPossibilitiesIn2()+1] = arcs.arc_capacity[i+instance.GetNumberOfLDCs()][j][mm+instance.GetNumberOfPossibilitiesIn2()+1];
						arcs.arc_capacity[j][i][mm+instance.GetNumberOfPossibilitiesIn2()+1] = 0;
						arcs.allowed_arcs_ldc[i][j][k][mm+instance.GetNumberOfPossibilitiesIn2()+1] = arcs.allowed_arcs_ldc[i+instance.GetNumberOfLDCs()][j][k][mm+instance.GetNumberOfPossibilitiesIn2()+1];
						arcs.allowed_arcs_ldc[j][i][k][mm+instance.GetNumberOfPossibilitiesIn2()+1] = 0;
					}
				}
			}
		}
	}

// To make sure links between dummy and LDC exist only one way
for (int i = 0 ; i < instance.duplicated_LDCS_PODs + instance.GetNumberOfLDCs() ; i++)
{
	for (int j = 0 ; j < instance.duplicated_LDCS_PODs + instance.GetNumberOfLDCs() ; j++)
	{
		for (int k = 0 ; k < instance.GetNumberOfVehicles() ; k++) 
		{ 
			for (int mm = 0 ; mm < instance.GetNumberOfScenarioTreeNodes() ; mm++) 
			{ 
				if ( i == j ) 
				{
					arcs.allowed_arcs_ldc[i][j][k][mm] = 0; 
					arcs.allowed_arcs_ldc[j][i][k][mm] = 0; 
				} 
				// This is from LDC to dummy POD..
				if (i < instance.GetNumberOfLDCs() && j == i + instance.GetNumberOfLDCs() )
				{ 
					arcs.allowed_arcs_ldc[i][j][k][mm] = 0; 
					arcs.allowed_arcs_ldc[j][i][k][mm] = 0; 
				} 
			} 
		} 
	} 
}

// Making sure all links between network and duplicated network has the right capacity
	for (int i = 0 ; i < instance.number_of_LDCs_PODs + instance.GetNumberOfLDCs() ; i++)
	{
			for (int mm = 0 ; mm < instance.GetNumberOfScenarioTreeNodes() ; mm++)
			{
				if ( i < instance.GetNumberOfLDCs())
				{
					arcs.arc_quality[i][i + instance.number_of_LDCs_PODs+instance.GetNumberOfLDCs()]  = 1000;
					arcs.arc_quality[i + instance.GetNumberOfLDCs()+instance.number_of_LDCs_PODs][i] = 0;
					arcs.arc_capacity[i][i + instance.number_of_LDCs_PODs + instance.GetNumberOfLDCs()][mm] = 1000*1000;
					arcs.arc_capacity[i + instance.number_of_LDCs_PODs + instance.GetNumberOfLDCs()][i][mm] = 0;
				}
				else
				{
					arcs.arc_quality[i][i + instance.number_of_LDCs_PODs] = 1000;
					arcs.arc_quality[i + instance.number_of_LDCs_PODs][i] = 1000;
					arcs.arc_capacity[i][i + instance.number_of_LDCs_PODs ][mm] = 1000*1000;
					arcs.arc_capacity[i + instance.number_of_LDCs_PODs ][i][mm] = 1000*1000;
				}
			}
	}




	
	for ( int i = 0 ; i < instance.number_of_LDCs_PODs+instance.GetNumberOfLDCs() ; i++)
	{	
		for (int j = 0 ; j < instance.number_of_LDCs_PODs + instance.GetNumberOfLDCs() ; j++)
		{
			if ( i == j )
			{
				dist[i][j] = 0;
				
			}
			else if ( i < instance.GetNumberOfLDCs() && j < instance.GetNumberOfLDCs())
			{
				distance_x = ldc[i+1+instance.GetNumberOfICDs()].GetCoordinateX()- ldc[j+1+instance.GetNumberOfICDs()].GetCoordinateX();
				distance_y = ldc[i+1+instance.GetNumberOfICDs()].GetCoordinateY()- ldc[j+1+instance.GetNumberOfICDs()].GetCoordinateY();
				distance = int(ceil(sqrt((distance_x*distance_x) + (distance_y*distance_y))));
				dist[i][j] = distance;
				dist[j][i] = distance;
				dist[i+instance.GetNumberOfLDCs()][j+instance.GetNumberOfLDCs()] = distance;
				dist[j+instance.GetNumberOfLDCs()][i+instance.GetNumberOfLDCs()] = distance;
				dist[i][i+instance.GetNumberOfLDCs()] = 0;
				dist[i+instance.GetNumberOfLDCs()][i] = 0;
				dist[i][j+instance.GetNumberOfLDCs()] = distance;
				dist[j+instance.GetNumberOfLDCs()][i] = distance;
			}
			
			else if ( i < instance.GetNumberOfLDCs() && j >= 2*instance.GetNumberOfLDCs())
			{
				distance_x = ldc[i+1+instance.GetNumberOfICDs()].GetCoordinateX()- pod[j-2*instance.GetNumberOfLDCs()].GetCoordinateX();
				distance_y = ldc[i+1+instance.GetNumberOfICDs()].GetCoordinateY()- pod[j-2*instance.GetNumberOfLDCs()].GetCoordinateY();
				distance = int(ceil(sqrt((distance_x*distance_x) + (distance_y*distance_y))));
				dist[i][j] = distance;
				dist[j][i] = distance;
				dist[i+instance.GetNumberOfLDCs()][j] = distance;
				dist[j][i+instance.GetNumberOfLDCs()] = distance;
			}
			
			else if ( i >= 2*instance.GetNumberOfLDCs() && j >= 2*instance.GetNumberOfLDCs())
			{
				distance_x = pod[i-2*instance.GetNumberOfLDCs()].GetCoordinateX()- pod[j-2*instance.GetNumberOfLDCs()].GetCoordinateX();
				distance_y = pod[i-2*instance.GetNumberOfLDCs()].GetCoordinateY()- pod[j-2*instance.GetNumberOfLDCs()].GetCoordinateY();
				distance = int(ceil(sqrt((distance_x*distance_x) + (distance_y*distance_y))));
				dist[i][j] = distance;
				dist[j][i] = distance;
			}
		}
	}

	for (int i = 0 ; i < instance.number_of_LDCs_PODs ; i++)
	{
		for (int j = 0 ; j < instance.number_of_LDCs_PODs ; j++)
		{
			dist[instance.number_of_LDCs_PODs + instance.GetNumberOfLDCs() + i][instance.number_of_LDCs_PODs + instance.GetNumberOfLDCs() + j] = dist[instance.GetNumberOfLDCs() + i][instance.GetNumberOfLDCs() + j];
		}
	}

// Setting arc cost and travel time in the whole network
	for (int i = 0 ; i < instance.duplicated_LDCS_PODs +instance.GetNumberOfLDCs(); i++)
	{
		for (int j = 0 ; j < instance.duplicated_LDCS_PODs +instance.GetNumberOfLDCs(); j++)
		{
			for (int k = 0 ; k < instance.GetNumberOfVehicles() ; k++)
			{
				for (int mm = 0 ; mm < instance.GetNumberOfScenarioTreeNodes() ; mm++)
				{
					if (arcs.arc_capacity[i][j][mm] != 0 && arcs.arc_quality[i][j] != 1000)
					{
						arcs.arc_cost_ldc[i][j][k][mm] = dist[i][j]*1000/arcs.arc_capacity[i][j][mm];						
						arcs.travel_time_ldc[i][j][k][mm] = 2* dist[i][j]*1000/arcs.arc_capacity[i][j][mm];
						arcs.arc_cost_ldc[j][i][k][mm] = dist[i][j]*1000/arcs.arc_capacity[i][j][mm];						
						arcs.travel_time_ldc[j][i][k][mm] = 2* dist[i][j]*1000/arcs.arc_capacity[i][j][mm];
						
					}
					else if (arcs.arc_capacity[i][j][mm] == 0)
					{
						arcs.arc_cost_ldc[i][j][k][mm] = 0;
						arcs.travel_time_ldc[i][j][k][mm] = 0;
					}

					
					if ( i < instance.GetNumberOfLDCs() )
					{
						arcs.arc_cost_ldc[i][i+instance.number_of_LDCs_PODs+instance.GetNumberOfLDCs()][k][mm]= 0;
						arcs.travel_time_ldc[i][i+instance.number_of_LDCs_PODs+instance.GetNumberOfLDCs()][k][mm] = 0 ;
					}
					else if ( i >= instance.GetNumberOfLDCs() && i < instance.GetNumberOfLDCs() + instance.number_of_LDCs_PODs)
					{
						arcs.arc_cost_ldc[i][i+instance.number_of_LDCs_PODs][k][mm]= 0;
						arcs.travel_time_ldc[i][i+instance.number_of_LDCs_PODs][k][mm] = 0 ;
					}
				}
			}
		}
	}

//Travel time and travel cost ICD--->LDC
	double dist_x, dist_y, dist_dia;
	int arc_cost_icd_ldc[4][200];

	for (int i = 0 ; i < instance.GetNumberOfICDs() ; i++)
	{
		for (int j = 0 ; j < instance.GetNumberOfLDCs() ; j++)
		{
			dist_x = icd[i+1].GetCoordinateX()- ldc[j+1+instance.GetNumberOfICDs()].GetCoordinateX();
			dist_y = icd[i+1].GetCoordinateY()- ldc[j+1+instance.GetNumberOfICDs()].GetCoordinateY();
			dist_dia = sqrt((dist_x*dist_x) + (dist_y*dist_y));
			//arc_cost_icd_ldc[i][j] = 3*dist_dia;
			arc_cost_icd_ldc[i][j] = int(ceil(3*dist_dia));
		}
	}

	for (int i = 0 ; i < instance.GetNumberOfICDs() ; i++)
	{
		for (int j = 0 ; j < instance.GetNumberOfLDCs() ; j++)
		{
			arcs.arc_cost_icd[i][j]= arc_cost_icd_ldc[i][j];
			arcs.travel_time_icd[i][j] = 2 * arcs.arc_cost_icd[i][j];
		}
	}

for (int i = 0 ; i < instance.number_of_LDCs_PODs + instance.GetNumberOfLDCs() ; i++)
{
	for (int j = 0 ; j < instance.number_of_LDCs_PODs + instance.GetNumberOfLDCs() ; j++)
	{
		for (int k = 0 ; k < instance.GetNumberOfVehicles() ; k++) 
		{ 
			for (int mm = instance.GetNumberOfPossibilitiesIn2()+1 ; mm < instance.GetNumberOfScenarioTreeNodes() ; mm++) 
			{ 
				if ( i < instance.GetNumberOfLDCs())
				{
					arcs.allowed_arcs_ldc[i][i+instance.number_of_LDCs_PODs+instance.GetNumberOfLDCs()][k][mm] = 1;
					arcs.allowed_arcs_ldc[i+instance.number_of_LDCs_PODs+instance.GetNumberOfLDCs()][i][k][mm] = 0;
				}
				else
				{
					arcs.allowed_arcs_ldc[i][i+instance.number_of_LDCs_PODs][k][mm] = 1;
					arcs.allowed_arcs_ldc[i+instance.number_of_LDCs_PODs][i][k][mm] = 1;
				}
			}
		}
	}
}

/// CREATING ALLOWED VEHICLE TYPES
	vector<int> row10;
	vector<vector<int> > row11;
 
	arcs.allowed_vehicle_types.resize(instance.duplicated_LDCS_PODs + instance.GetNumberOfLDCs());
	for (int i = 0 ; i < instance.duplicated_LDCS_PODs + instance.GetNumberOfLDCs(); i++)
	{
		arcs.allowed_vehicle_types[i].resize(instance.GetNumberOfVehicles());
		for (int j = 0 ; j < instance.GetNumberOfVehicles() ; j++)
		{
			arcs.allowed_vehicle_types[i][j].assign(instance.GetNumberOfScenarioTreeNodes(),0);
		}
	}




	for (int i = 0 ; i < instance.duplicated_LDCS_PODs+ instance.GetNumberOfLDCs() ; i++)
	{
		for (int j = 0 ; j < instance.duplicated_LDCS_PODs + instance.GetNumberOfLDCs(); j++)
		{
			for (int k = 0 ; k < instance.GetNumberOfVehicles() ; k++)
			{
				for (int m = 0 ; m < instance.GetNumberOfScenarioTreeNodes() ; m++)
				{
						if ( arcs.allowed_arcs_ldc[i][j][k][m] == 1 || arcs.allowed_arcs_ldc[j][i][k][m] == 1)
						{
							arcs.allowed_vehicle_types[j][k][m] = 1;
						}
				}
			}
		}
	}


}//end of creating arcs function

/////////////////////////////////////////////////////////////////////////////////////
//Function: Creates a random quality depending on pre-quality and dist from epicenter
int CreateRandomQuality(int now_quality, int disti, int distj)
{

	int dist = 0;
	if (disti < distj)
	{dist = disti;}
	else
	{dist = distj;}

	int b;
	b = rand()%10 +1;
	int c = 0;
	
	switch(now_quality)
	{
		case 0:
		{
			c = 0;
			break;
		}
		case 1:
		{
			if ( dist < 200)
			{
				if ( b > 3)
				{c = 0 ;}
				else
				{c = 1; }
			}
			else if ( dist < 600 ) 
			{
				if ( b > 5 )
				{ c = 0; }
				else
				{c = 1; }
			}
			else
			{
				if ( b == 1 )
				{ c = 0; }
				else
				{ c = 1 ; }
			}
			break;
		}
		
		case 2:
		{
			if ( dist < 200)
			{
				if ( b < 4)
				{c = 0 ;}
				else if ( b > 3 && b < 8 )
				{c = 1; }
				else 
				c = 0;
			}
			else if ( dist < 600 ) 
			{
				if ( b < 3)
				{c = 0 ;}
				else 
				{c = 1; }
			}
			else
			{
				if ( b == 1 )
				{ c = 0; }
				else if (b == 2 || b == 3)
				{
					c = 1;
				}
				else
					c = 2 ; 
			}
			break;
		}
		
		case 3:
		{
			if ( dist < 200)
			{
				if ( b < 3)
				{c = 0 ;}
				else if ( b > 2 && b < 6 )
				{c = 2; }
				else if ( b > 5 && b < 9 )
				c = 1;
				else
				c = 3;
			}
			else if ( dist < 600 ) 
			{
				if ( b < 2)
				{c = 0 ;}
				else if ( b > 3 && b < 7 )
				{c = 2; }
				else if ( b > 6 && b < 10 )
				c = 1;
				else
				c = 3;
			}
			else
			{
				if ( b < 2)
				{c = 0 ;}
				else if ( b > 4 && b < 8 )
				{c = 2; }
				else if ( b > 7 && b < 11 )
				c = 1;
			}
			break;
		}
	}
	return c;
	
}





