//This main_functions.h file defines functions used in main.cpp
#ifndef MAIN_FUNCTIONS_H
#define MAIN_FUNCTIONS_H
#include <vector>
#include <map>
#include "stochastic.h"
#include "ICD.h"


int RandomCoord();
int RandomForKvadrantX(int a);
int RandomForKvadrantY(int a);
int CreateRandomQuality(int now_quality, int dist, int dist2);
int ArcCapacity();
int ArcQuality();
void CreateEarthquake(Location &earthquake);


////Stochastic functions
void CreateStochastic(Stochastic &instance);
void CreateStochICDs(ICD &icds, int nummer, Stochastic set);
void CreateStochLDCs(LDC &ldcs, Location earth, Stochastic stochset, int nummer);
void CreateStochArcs(Stochastic stocset, std::map<int, ICD>icd, std::map<int, LDC>ldc, std::vector<PODD>pod, Location earthquake, Arcs& arcs);
double CreateActualDemand(double demand);
int CreateActualVehicles(int vehicles);

void CreateStochFile(Stochastic instance, Location earth, std::map<int, ICD>icd, std::map<int, LDC>ldc, std::vector<PODD>pod, Arcs arcs);

#endif 