//This file creates text files
#include "main_functions.h"
#include "location.h"
#include "ICD.h"
#include "stochastic.h"
#include <fstream>
#include <iostream>
#include <vector>
#include <math.h>

using namespace std;


void CreateStochFile(Stochastic instance, Location earth, map<int, ICD>icd, map<int,LDC>ldc, vector<PODD>pod, Arcs arcs)
{
	cout << "\n\nStart writing to file" << endl;
	ofstream output ("LDC_90.txt"); //Textfile name: L2: 2 LDCs, P3: 3 PODs, 2_2:2 possibilities in stage 2, 3 in stage 3 
	if(output.is_open())
	{

//////////////////////////////////////SETS///////////////////////////////////////////////////////////
////////NUMBER OF COMMODITY TYPES
		
		output << "NCOMMODITY_TYPES         :   " << instance.GetNumberOfCommodities() << endl; //25 spaces from start to : then 3
	
////////NUMBER OF ICDS	
		output << "NICDS                    :   " << instance.GetNumberOfICDs() << endl;

////////NUMBER OF LDCS
		output << "NLDCS                    :   " << instance.GetNumberOfLDCs() << endl;

////////NUMBER OF NODES
		output << "NNODES                   :   " << instance.GetNumberOfNodes() << endl;

////////NUMBER OF PODS
		output << "NPODS                    :   " << instance.GetNumberOfPODs() << endl;

////////NUMBER OF UTILITY INTERVALS
		output << "NUTILITY_INTERVALS       :   " << instance.GetNumberOfUtilityIntervals() << endl;

/////////NUMBER OF VEHICLE TYPES
		output << "NVEHICLE_TYPES           :   " << instance.GetNumberOfVehicles() << endl;

/////////NUMBER OF SCENARIO TREE NODES 
		output << "NSCENARIO_TREE_NODES     :   " << instance.GetNumberOfScenarioTreeNodes() << endl;

/////////NUMBER OF STAGES
		output << "NSTAGES                  :   " << instance.GetNumberOfStages() << endl;
//////////////////////////////////ELEMENTS CREATED HERE////////////////////////////////////////////////////////////////
////////PROBABILITY
		double prob, prob2;
		prob = 1/instance.GetNumberOfPossibilitiesIn2();
		prob = prob/instance.GetNumberOfPossibilitiesIn3();
		prob2 = 1 / instance.GetNumberOfPossibilitiesIn2();
		output << "PROB                     : [ " ;
		output << 0 << "      ";
		for (int i = 0 ; i < instance.GetNumberOfPossibilitiesIn2() ; i++)
		{
				output << prob2 << "      " ;
		}
		for ( int i = 0 ;  i < instance.GetNumberOfPossibilitiesIn2() * instance.GetNumberOfPossibilitiesIn3(); i++)
		{
			output << prob << "      " ;
		}
		output << "]" << endl << endl;
		cout << "PREDECESSOR" << endl;
////////PREDECESSOR
		//int predecessor[500];
		vector<int>predecessor;
		
		for ( int i = 0; i < instance.GetNumberOfScenarioTreeNodes(); i++)
		{
			predecessor.push_back(0);
		}
			
		predecessor[0] = 0;
		int k = 1;
		for (int i = 1 ; i < instance.GetNumberOfPossibilitiesIn2()+1 ; i++)
		{
				predecessor[i] = 1;
		}
		int m = instance.GetNumberOfPossibilitiesIn2()+1;
		for (int i = 0; i < instance.GetNumberOfPossibilitiesIn2(); i++)
		{
				for (int j = 0 ; j < instance.GetNumberOfPossibilitiesIn3() ; j++)
				{
					predecessor[m] =  k+1;
					m++;
				}
				k++;

		}
		


		output << "PREDECESSOR                : [ ";
		for (int i = 0 ; i < instance.GetNumberOfScenarioTreeNodes() ; i++)
		{
			output << predecessor[i] << "      ";

		}
		output << "]" << endl << endl;

///////////////////////////////////DATA////////////////////////////////////////////////////////////////
////////BUDGET
		output << "BUDGET                   :   " << instance.GetBudget() << endl;
////////BUDGET
		output << "BUDGET_PENALTY           :   " << instance.budget_penalty << endl;
////////MAX CONVOY TIME
		output << "MAX_CONVOY_TIME          :   " << instance.GetMaxConvoyTime() << endl;
////////VEHICLE_CAPACITY_ICD
		output << "VEHICLE_CAPACITY_ICD     :   " << instance.GetVehicleCapacityICD() << endl<< endl;
		

////////COMMODITY COST
		output << "COMMODITY_COST           : [ ";
		for (int i = 0 ; i < instance.GetNumberOfCommodities() ; i++)
		{
			output << instance.commodity_cost[i] << "      ";   
		}
		output << "]" << endl << endl;

////////COMMODITY SIZE
		output << "COMMODITY_SIZE           : [ ";
		for (int i = 0 ; i < instance.GetNumberOfCommodities() ; i++)
		{
			output << instance.commodity_size[i] << "      ";
		}
		output << "]" << endl << endl;
//////Vehicle Capacity LDC
		output << "VEHICLE_CAPACITY_LDC     : [ ";

			for (int j = 0 ; j < instance.GetNumberOfVehicles() ; j++)
			{
				output << instance.vehicle_capacity[j] << "      ";
			}
			output << "]" << endl << endl;
		
///////Vehicle SIZE
		output << "VEHICLE_SIZE             : [ ";

			for (int j = 0 ; j < instance.GetNumberOfVehicles() ; j++)
			{
				output << instance.vehicle_size[j] << "      ";
			}

		output << "]" << endl << endl;

////////No of vehilces icd
		output << "NO_OF_VEHICLES_ICD       : [ ";
		for (int i = 0 ; i < instance.GetNumberOfICDs() ; i++)
		{
			output << icd[i+1].GetNumberOfVehicles() << "      " ;
		}
		output << "]" << endl << endl;
	
///////SUPPLY
		output << "SUPPLY                   : [ ";
		for (int i = 0 ;  i < instance.GetNumberOfICDs() ; i++)
		{
			for (int j = 0; j < instance.GetNumberOfCommodities() ; j++)
			{
				output << icd[i+1].supply[j] << "      ";
			}

			if ( i != instance.GetNumberOfICDs()-1)
			{
				output << endl << "                             ";
			}
			else
			{
				output << "]" << endl << endl;
			}
		}	
	
		cout << "LDC_CAPACITY-->" << endl;
////////LDC capacity
		output << "LDC_CAPACITY             : [ ";
		for (int i = 0 ; i < instance.GetNumberOfLDCs() ; i++)
		{
			output << ldc[i+1+instance.GetNumberOfICDs()].GetLdcCapacity() << "      " ;
		}
		output << "]" << endl << endl;

///////OPENING COST
		output << "OPENING_COST             : [ ";
		for (int i = 0 ; i < instance.GetNumberOfLDCs() ; i++)
		{
			output << ldc[i+1+instance.GetNumberOfICDs()].GetOpeningCost() << "      ";
		}
		output << "]" << endl << endl;

////////DEMAND
		output << "DEMAND                   : [ \n";
		for (int i = 0 ; i< instance.GetNumberOfPODs() ; i++)
		{
			for (int j = 0 ; j < instance.GetNumberOfCommodities(); j++)
			{
				for (int k = 0 ; k < instance.GetNumberOfScenarioTreeNodes(); k++)
				{
					output << "( " << i+1 << ", " << j+1 << ", " << k+1 << " )      ";
					output << pod[i].demand[j][k];
					output << endl;
				}
			}
		}
		output << "]" << endl << endl;
		cout << "UTILITY INTERVAL_SIZE-->" << endl;
////////UTILITY INTERVAL SIZE
		output << "UTILITY_INTERVAL_SIZE    : [ \n";
		for (int i = 0 ; i < instance.GetNumberOfPODs() ; i++)
		{
			for (int j = 0 ; j < instance.GetNumberOfCommodities() ; j++)
			{
				for (int k = 0 ; k < instance.GetNumberOfUtilityIntervals() ; k++)
				{
					for (int m = 0 ; m < instance.GetNumberOfScenarioTreeNodes() ; m++)
					{
						output << "( " << i+1 << ", " << j+1 << ", " << k+1 << ", " << m+1 << " )      ";
						output << pod[i].ut_interval_size[j][k];
						output << endl;
					}
				}
			}
		}
		output << " ] " << endl << endl;

//////////UTILITY FActor
		output << "UTILITY_FACTOR          : [ \n";
		for (int i = 0 ; i < instance.GetNumberOfPODs() ; i++)
		{
			for (int j = 0 ; j < instance.GetNumberOfCommodities() ; j++)
			{
				for (int k = 0 ; k < instance.GetNumberOfUtilityIntervals() ; k++)
				{
					for (int m = 0 ; m < instance.GetNumberOfScenarioTreeNodes() ; m++)
					{
						output << "( " << i+1 << ", " << j+1 << ", " << k+1 << ", " << m+1 << " )      ";
						output << pod[i].ut_factor[j][k][m];
						output << endl;
					}
				}
			}
		}
		output << " ] " << endl << endl;

		cout << "NO_OF_VEHICLE_LDC-->" << endl;
//////////NO of vehicles LDC
		output << "NO_OF_VEHICLES_LDC     : [ \n";
		for (int i = 0 ; i < instance.GetNumberOfLDCs() ; i++)
		{
			for (int j = 0 ; j < instance.GetNumberOfVehicles() ; j++)
			{
				for (int k = 0 ; k < instance.GetNumberOfScenarioTreeNodes() ; k++)
				{
					output << "(" << i+1 << ", " <<  j+1 << ", " << k+1 << " )      ";
					output << ldc[i+1+instance.GetNumberOfICDs()].vehicles_stages[j][k];
					output << endl;
				}
			}

		}
		
		output << "]" << endl << endl;

		cout << "ALLOWED_ARCS_ICD-->" << endl;
////// ALLOWED ARCS ICD
		output << "ALLOWED_ARCS_ICD      : [ " << endl;
 
		for (int i = 0 ; i < instance.GetNumberOfICDs() ; i++)
		{
			for (int j = 0 ; j < instance.GetNumberOfLDCs() ; j++)
			{
				output << "( " << i+1 << ", " << j+1 << " ) " ;
				output << arcs.allowed_arcs_icd[i][j];
				output << endl;
			}
		}

		output << "]" << endl << endl;

		cout << "ALLOWED ARCS LDC-->" << endl;
////////Allowed arcs LDC

		output << "ALLOWED_ARCS_LDC      : [ " << endl;
		
		for (int i = 0 ; i < instance.duplicated_LDCS_PODs + instance.GetNumberOfLDCs(); i++)
		{
			for (int j = 0 ; j < instance.duplicated_LDCS_PODs + instance.GetNumberOfLDCs(); j++)
			{
				for (int k = 0 ; k < instance.GetNumberOfVehicles() ; k++)
				{
					for (int m = 0 ; m < instance.GetNumberOfScenarioTreeNodes() ; m++)
					{
						output << "(" << i+1 << ", " <<  j+1 << ", " << k+1 << ", " << m+1 << " )      ";
						output << arcs.allowed_arcs_ldc[i][j][k][m];
						output << endl;
					}
				}
			}
			cout << i+1 << " of " << instance.duplicated_LDCS_PODs + instance.GetNumberOfLDCs() << " nr 1" << endl;
		}
		output << "]" << endl << endl;

////////Allowed arcs LDC

		cout << "ALLOWED_VEHICLE_TYPES-->" << endl;
		output << "ALLOWED_VEHICLE_TYPES : [ " << endl;
		
			for (int j = 0 ; j < instance.duplicated_LDCS_PODs + instance.GetNumberOfLDCs(); j++)
			{
				for (int k = 0 ; k < instance.GetNumberOfVehicles() ; k++)
				{
					for (int m = 0 ; m < instance.GetNumberOfScenarioTreeNodes() ; m++)
					{
						output << "(" <<  j+1 << ", " << k+1 << ", " << m+1 << " )      ";
						if ( j < instance.number_of_LDCs_PODs)
						{
							output << arcs.allowed_vehicle_types[j][k][m];
							output << endl;
						}
						else
						{
							output << arcs.allowed_vehicle_types[j-instance.number_of_LDCs_PODs][k][m];
							output << endl;
						}
					}
				}
			}

		output << "]" << endl << endl;


////////////////////////////////////////////////////////////////////////////////////
/////////Allowed vehicle types

		cout << "ARC_CAPACITY-->" << endl;
		output << "ARC_CAPACITY           : [ " << endl;
		
		for (int i = 0 ; i < instance.duplicated_LDCS_PODs + instance.GetNumberOfLDCs(); i++)
		{
			for (int j = 0 ; j < instance.duplicated_LDCS_PODs+ instance.GetNumberOfLDCs(); j++)
			{
				for (int m = 0 ; m < instance.GetNumberOfScenarioTreeNodes() ; m++)
				{
						output << "(" << i+1 << ", " <<  j+1 << ", " << m+1 << " )      ";
						output << arcs.arc_capacity[i][j][m];
						output << endl;

				}
			}
			cout << i+1 << " of " << instance.duplicated_LDCS_PODs + instance.GetNumberOfLDCs() << " nr 2" <<endl;
		}
		output << "]" << endl << endl;


		cout << "TRAVEL_TIME_ICD-->" << endl;
////// TRAVELTIME ICD
		output << "TRAVEL_TIME_ICD       : [ " << endl;
 
		for (int i = 0 ; i < instance.GetNumberOfICDs() ; i++)
		{
			for (int j = 0 ; j < instance.GetNumberOfLDCs() ; j++)
			{
				output << "( " << i+1 << ", " << j+1 << " ) " ;
				output << arcs.travel_time_icd[i][j];
				output << endl;
			}
		}

		output << "]" << endl << endl;


		cout << "ARC_COST_ICD-->" << endl;
////// TRAVEL COST ICD
		output << "ARC_COST_ICD         : [ " << endl;
  
		for (int i = 0 ; i < instance.GetNumberOfICDs() ; i++)
		{
			for (int j = 0 ; j < instance.GetNumberOfLDCs() ; j++)
			{
				output << "( " << i+1 << ", " << j+1 << " ) " ;
				output << arcs.arc_cost_icd[i][j];
				output << endl;
			}
		}

		output << "]" << endl << endl;

////////Travel Time LDC
		cout << "TRAVEL_TIME_LDC-->" << endl;
		output << "TRAVEL_TIME_LDC     : [ " << endl;
		
		for (int i = 0 ; i < instance.duplicated_LDCS_PODs + instance.GetNumberOfLDCs(); i++)
		{
			for (int j = 0 ; j < instance.duplicated_LDCS_PODs+ instance.GetNumberOfLDCs(); j++)
			{
				for (int k = 0 ; k < instance.GetNumberOfVehicles() ; k++)
				{
					for (int m = 0 ; m < instance.GetNumberOfScenarioTreeNodes() ; m++)
					{
						output << "(" << i+1 << ", " <<  j+1 << ", " << k+1 << ", " << m+1 << " )      ";
						output << arcs.travel_time_ldc[i][j][k][m];
						output << endl;
					}
				}
			}
		cout << i+1 << " of " << instance.duplicated_LDCS_PODs + instance.GetNumberOfLDCs()<< " nr 3" << endl;
		}
		output << "]" << endl << endl;
		
		
////////Arc Cost LDC
		cout << "ARC_COST_LDC-->" << endl;
		output << "ARC_COST_LDC        : [ " << endl;
		
		for (int i = 0 ; i < instance.duplicated_LDCS_PODs+ instance.GetNumberOfLDCs() ; i++)
		{
			for (int j = 0 ; j < instance.duplicated_LDCS_PODs+ instance.GetNumberOfLDCs(); j++)
			{
				for (int k = 0 ; k < instance.GetNumberOfVehicles() ; k++)
				{
					for (int m = 0 ; m < instance.GetNumberOfScenarioTreeNodes() ; m++)
					{
						output << "(" << i+1 << ", " <<  j+1 << ", " << k+1 << ", " << m+1 << " )      ";
						output << arcs.arc_cost_ldc[i][j][k][m];
						output << endl;
					}
				}
			}
			cout << i+1 << " of " << instance.duplicated_LDCS_PODs + instance.GetNumberOfLDCs()<< " nr 4" << endl;
		}
		output << "]" << endl << endl;
		
////////Arc Cost LDC
		cout << "STAGE_SCENARIO_TREE_NODES-->" << endl;
		output << "STAGE_SCENARIO_TREE_NODES: [ " << endl;
		for (int i = 1 ; i < instance.GetNumberOfScenarioTreeNodes()+1 ; i++)
		{
			for (int j = 1 ; j < 4 ; j++)
			{
				output << "(" << i << ", " << j << " )      ";
				
				if (i == 1  && j == 1)
				{
					output << 1 << endl; 
				}
				else if ( i > 1 && i <= 1+instance.GetNumberOfPossibilitiesIn2() && j == 2)
				{
					output << 1 << endl;
				} 
				else if ( i > 1+ instance.GetNumberOfPossibilitiesIn2() && j == 3)
				{
					output << 1 << endl;
				}
				else
					output << 0 << endl;
			}
		}

		output << "]" << endl << endl;
		cout << "COORDX-->" << endl;		
	output << "COORDX : [" << endl;
	for ( int i = 0 ; i < instance.GetNumberOfICDs(); i++)
	{
		output << icd[i+1].GetCoordinateX() << endl;
	}
	
	for (int i = 0 ; i < instance.GetNumberOfLDCs() ; i++ )
	{
		output << ldc[i+1+instance.GetNumberOfICDs()].GetCoordinateX() << endl;
	}
	
	for (int i = 0 ; i < instance.GetNumberOfLDCs() ; i++ )
	{
		output << ldc[i+1+instance.GetNumberOfICDs()].GetCoordinateX() << endl;
	}
	
	for (int i = 0 ; i < instance.GetNumberOfPODs() ; i++)
	{
	output << pod[i].GetCoordinateX() <<endl;
	}

	output << "]" << endl << endl;
		cout << "COORDY-->" << endl;
	output << "COORDY : [" << endl;
	for ( int i = 0 ; i < instance.GetNumberOfICDs(); i++)
	{
	output << icd[i+1].GetCoordinateY() << endl;
	}
	
	for (int i = 0 ; i < instance.GetNumberOfLDCs() ; i++ )
	{
	output << ldc[i+1+instance.GetNumberOfICDs()].GetCoordinateY() << endl;
	}
	
	for (int i = 0 ; i < instance.GetNumberOfLDCs() ; i++ )
	{
	output << ldc[i+1+instance.GetNumberOfICDs()].GetCoordinateY() << endl;
	}
	
	for (int i = 0 ; i < instance.GetNumberOfPODs() ; i++)
	{
	output << pod[i].GetCoordinateY() << endl;
	}

	output << "]" << endl << endl;

			cout << "COORDXDUP-->" << endl;
	output << "COORDXDUP : [" << endl;

	for (int i = 0 ; i < instance.GetNumberOfICDs() ; i++ )
	{
	output << 0 << endl;
	}


	for (int i = 0 ; i < instance.GetNumberOfLDCs() ; i++ )
	{
	output << 1300+ldc[i+1+instance.GetNumberOfICDs()].GetCoordinateX() << endl;
	}

	for (int i = 0 ; i < instance.GetNumberOfPODs() ; i++)
	{
	output << 1300+pod[i].GetCoordinateX() << 	endl;
	}

	output << "]" << endl << endl;

	output << "COORDYDUP : [" << endl;

	for (int i = 0 ; i < instance.GetNumberOfICDs() ; i++ )
	{
	output << 0 << endl;
	}

	for (int i = 0 ; i < instance.GetNumberOfLDCs() ; i++ )
	{
		output << ldc[i+1+instance.GetNumberOfICDs()].GetCoordinateY() << endl;
	}
	
	for (int i = 0 ; i < instance.GetNumberOfPODs() ; i++)
	{
		output << pod[i].GetCoordinateY() << endl;
	}

	output << "]" << endl << endl;				
		
		cout << "EEPICENTERX AND Y-->" << endl;
	output << "EPICENTER_X :  " <<  earth.GetCoordinateX();
	output << endl;
	
	
	output << "EPICENTER_Y :  " <<  earth.GetCoordinateY();
	output << endl;



		
////////
	}
	output.close();
}
